#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <signal.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <stdlib.h>
#include <vector>
#include <string>

using namespace std;

struct client
{
  string ip;
  int fd;
};

class Error {};

vector<client> clients;

void *thread_comm(void *);
int load_address();

int main(int argc, char **argv)
{
	if (argc !=2)
	{
		printf("Usage: ./server [port]\n");
		exit(0);
	}

	int server_sockfd;
	if ((server_sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		perror("socket error");
		exit(0);
	}

	int val = 1;
	if (setsockopt(server_sockfd, SOL_SOCKET, SO_REUSEADDR, (char *)&val, sizeof val) < 0)
	{
		perror("setsockopt");
		close(server_sockfd);
		exit(0);
	}

	struct sockaddr_in serveraddr;
	bzero(&serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr.sin_port = htons(atoi(argv[1]));
	if (bind(server_sockfd, (struct sockaddr*)&serveraddr, sizeof(serveraddr)) == -1)
	{
		perror("bind error");
		exit(0);
	}

	printf("!! waiting connection !!\n");
	if (listen(server_sockfd, 5) == -1)
	{
		perror("bind error");
		exit(0);
	}

	while(1)
	{
		struct sockaddr_in clientaddr;
		int client_len;
		int client_sockfd;
		
		try
		{
			client_sockfd = accept(server_sockfd, (struct sockaddr*)&clientaddr, (socklen_t*)&client_len);
			client cl;
			cl.ip = inet_ntoa(clientaddr.sin_addr);
			cl.fd = client_sockfd;
			clients.push_back(cl);

			pthread_t p_thread;
			if (pthread_create(&p_thread, NULL, thread_comm, (void *)client_sockfd) == -1)
			{
			perror("create thread fail\n");
			exit(0);
			}
		}

		catch (Error&) {}
	}
	shutdown(server_sockfd, 2); 
	close(server_sockfd); 
} 

void *thread_comm(void* data)
{
 int sockfd = (int)data;
 string ip;
 for(vector<client>::iterator ci = clients.begin(); ci != clients.end(); ci++)
 if(ci->fd ==sockfd)
 ip = ci->ip;
 printf("%s",ip);
 printf("connect to %s .. \n", ip.c_str());
 printf("now connection : %d \n", clients.size());

 char buf[1024];

 sprintf(buf, "%s|connected|%d\n", ip.c_str(), clients.size());
 for(vector<client>::iterator ci = clients.begin(); ci != clients.end(); ci++)
 {
  if(write(ci->fd, buf, strlen(buf)+1) == -1)
  printf("write error to %s\n", ip.c_str());
 }

 char c;
 string line;
 try
 {
  while(read(sockfd, &c, 1) > 0)
  {
   line +=c;
   if (c == '\n')
   {
     line = ip + "|" + line;
     for(vector<client>::iterator ci = clients.begin(); ci != clients.end(); ci++)
     {
      if(write(ci->fd, line.c_str(), line.length()+1) == -1)
      {
       printf("write error to %s\n", ip.c_str());
       break;
      }
     }
     line.clear();
   }
  }
 }
 catch (Error&) {}

 shutdown(sockfd, 2); 
 close(sockfd); 
 printf("disconnected to %s\n", ip.c_str()); 
  
 for(vector<client>::iterator ci = clients.begin(); ci != clients.end(); ci++) 
  if(ci->fd == sockfd) 
  { 
  clients.erase(ci,ci+1); 
  break; 
  } 

 try 
 { 
  sprintf(buf, "%s|disconnected|%d\n", ip.c_str(), clients.size()); 
  for(vector<client>::iterator ci = clients.begin(); ci != clients.end(); ci++) 
  { 
  if(write(ci->fd, buf, strlen(buf)+1) == -1) 
    printf("write error to %s\n", ip.c_str()); 
  } 
 } 
 catch (Error&) {} 

 printf("now connected: %d \n", clients.size()); 

 return (void *)NULL; 
}
